#include "usart.h"
#include "device.h"
#include "spi2.h"
#include "ult.h"
#include "socket.h"
#include "w5500.h"
#include "24c16.h"
#include "md5.h"
#include "string.h"
#include "config.h"
extern uint8 txsize[];										// ⲿSocketͻС
extern uint8 rxsize[];										// ⲿSocketջС
extern CONFIG_MSG  ConfigMsg;
//uint8 ip[4]={224,0,0,252};
uint8 buffer[2048]="udp,test!";												// һ2KB飬Socketͨ
//extern uint8 DEFAULT_RIP[4];
//uint8 d_mac[6]={0x01,0x00,0x5e,0x2B,0x17,0x43};
uint8 rIP[4];
uint16 rPort;
uint8 DIP[4]={224,1,1,8};
//uint8 DHAR[6]={0x01,0x00,0x5e,0x01,0x01,0x08};
uint8 DHAR[6]={0x01,0x00,0x5E,0x01,0x01,0x08};
uint16 DPORT=3000;
int main(void)
{
	int i =0;
  //uint8 remote_ip[4]={192,168,1,108};			// ԶIPַ
	uint16 remote_port=60000;								// Զ̶˿
  uint16 local_port=5005;									// ʼһض˿
  uint16 len=0;

  /***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
   NVIC_SetVectorTable(0x08000000,0x8000);
	/***** жϿ *****/
	NVIC_Configuration();
	
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();			
	WIZ_SPI_Init();
	
	/***** ڳʼ *****/
	USART1_Init(); 		
	
	/***** ʼeeprom *****/
  at24c16_init();
	
	/***** ӲW5500 *****/
	Reset_W5500();
	
	/***** W5500IPϢʼ *****/
	set_default(); 														// ĬMACIPGWSUBDNS
	set_network();														// óʼIPϢӡʼ8Socket
        

	/*Socket״̬MCUͨSn_SR(0)ֵжSocketӦôں״̬
		Sn_SR״̬
		0x00		SOCK_CLOSED
		0x13		SOCK_INIT
		0x14		SOCK_LISTEN
		0x17		SOCK_ESTABLISHED
		0x1C		SOCK_CLOSE_WAIT
		0x22		SOCK_UDP
	*/
	while(1)																												// Socket״̬
	{
		switch(getSn_SR(0))/*??socket 0???*/
      {
         case SOCK_UDP:/*socket ?????????*/
           if(getSn_IR(0) & Sn_IR_RECV)
          {
            setSn_IR(0, Sn_IR_RECV);/*Sn_IR??0??1*/
          }
					 if(getIR() & 0x10)
          {
             printf("get wake on line\r\n");
						setIR(0x10);
						
          }
           if((len=getSn_RX_RSR(0))>0)
           { 
              recvfrom(0, buffer, len, DIP,&rPort);
              printf("%d.%d.%d.%d:%d", rIP[0],rIP[1],rIP[2],rIP[3],rPort);
              printf("%s", buffer);
              sendto(0, buffer,len, DIP, DPORT);/*W5200?????????????*/
            }
           break; 
         case SOCK_CLOSED:/*socket ??*/
           //socket(0,Sn_MR_UDP,30000,0);/*???socket 0????*/
          // setDIPR(0,DIP);
          // setDHAR(0,DHAR);
           //setDPORT(0,DPORT);
           socket(0,Sn_MR_UDP,30000,0);/*???socket 0????*/
				   setIMR(0x10);
				   setMR(MR_WOL);
           break;
       }
	}
}
